#include <sybfront.h>
#include <sybdb.h>
#include <syberror.h>
#include <sybfrs.h>

#if MSDOS
#	include	"aforms.h"
#endif /* MSDOS */

/*
**  ERR_HANDLER
**  Catch DB-LIBRARY error messages.
*/
int err_handler(dbproc, severity, dberr, oserr, dberrstr, oserrstr)

DBPROCESS       *dbproc;
int             severity;
int             dberr;
int             oserr;
char            *dberrstr;
char            *oserrstr;
{
	char msgbuf[100];

	/* The message handler has already handled any SQL Server messages. */
	if (dberr == SYBESMSG)
	{
		return(INT_CANCEL);
	}

	/* Eliminate warning messages on precision loss. */
	if (dberr == SYBECLPR)
	{
		return(INT_CANCEL);
	}
		
	/* Otherwise, print the DB-LIBRARY error. */
	sprintf(msgbuf, "DB-LIBRARY error:\n\t%s\n", dberrstr);
	fsmessage(msgbuf);

	/* Print any operating system errors. */
	if (oserr != DBNOERR)
	{
		sprintf(msgbuf, "Operating system error:\n\t%s\n", oserrstr);
		fsmessage(msgbuf);
	}

	return(INT_CANCEL);
}
